/*******************************************************************************
 * FoxUIServerDetailsWidget generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxUIServerDetailsWidget extends FoxUIBaseWidget within GFxMoviePlayer
    native(UI);

const CONTEXT_PRESENCE_MENUPRESENCE = 0;
const CONTEXT_PRESENCE_PRESENCE_PLAYING = 1;
const CONTEXT_GAME_MODE = 0x0000800B;
const CONTEXT_GAME_MODE_DM = 0;
const CONTEXT_GAME_MODE_TDM = 1;
const CONTEXT_GAME_MODE_CP = 2;
const CONTEXT_GAME_MODE_TKOTH = 3;
const CONTEXT_GAME_MODE_CTF = 4;
const CONTEXT_GAME_MODE_CTDM = 5;
const CONTEXT_GAME_MODE_EOTS = 6;
const CONTEXT_GAME_MODE_PL = 7;
const CONTEXT_GAME_MODE_KC = 8;
const CONTEXT_GAME_MODE_OS = 9;
const CONTEXT_GAME_MODE_SND = 10;
const CONTEXT_GAME_MODE_DETONATE = 1002;
const CONTEXT_GAME_MODE_LMS = 1003;
const CONTEXT_GAME_MODE_LTS = 1004;
const CONTEXT_GAME_MODE_BO = 1005;
const CONTEXT_LOCKEDSERVER = 1;
const CONTEXT_MAPNAME = 2;
const CONTEXT_MAPNAME_CUSTOM = 0;
const CONTEXT_MAPNAME_BLACKMARKET = 1;
const CONTEXT_MAPNAME_BRUTALISM = 2;
const CONTEXT_MAPNAME_CURFEW = 3;
const CONTEXT_MAPNAME_DERAILER = 4;
const CONTEXT_MAPNAME_DROPZONE = 5;
const CONTEXT_MAPNAME_FLOODGATE = 6;
const CONTEXT_MAPNAME_MAUL = 7;
const CONTEXT_MAPNAME_PITFALL = 8;
const CONTEXT_MAPNAME_POSTALLEY = 9;
const CONTEXT_MAPNAME_SKYFIRE = 10;
const CONTEXT_MAPNAME_SLUMLORD = 11;
const CONTEXT_MAPNAME_WHARFARE = 12;
const CONTEXT_MAPNAME_ZEROPOINT = 13;
const CONTEXT_MAPNAME_STREETFIGHT = 14;
const CONTEXT_MAPNAME_TOURISTTRAP = 15;
const CONTEXT_MAPNAME_BURIALGROUND = 16;
const CONTEXT_MAPNAME_BRICKANDMORTAR = 17;
const CONTEXT_LOCKEDSERVER_NO = 0;
const CONTEXT_LOCKEDSERVER_YES = 1;
const PROPERTY_CUSTOMMAPNAME = 0x40000001;
const PROPERTY_CUSTOMGAMEMODE = 0x40000002;
const PROPERTY_SERVERDESCRIPTION = 0x40000003;
const PROPERTY_MAPNAME = 0x40000004;
const PROPERTY_GAMETYPE = 0x40000005;
const PROPERTY_GAMEPASSWORD = 0x40000006;
const PROPERTY_ADMINPASSWORD = 0x40000007;
const PROPERTY_OWNERNAME = 0x40000008;
const PROPERTY_SERVERNAME = 0x40000009;
const PROPERTY_SERVERID = 0x4000000A;
const PROPERTY_GAME_VERSION = 0x50000074;
const PROPERTY_GAME_OPEN = 0x10000076;
const PROPERTY_PUBLIC_GAME = 0x10000078;
const PROPERTY_PLAYLISTNAME = 0x10000079;
const PROPERTY_MAPINDEX = 0x1000007A;
const PROPERTY_GAMEINDEX = 0x1000007B;
const PROPERTY_MINLEVEL = 0x1000007C;
const PROPERTY_MAXLEVEL = 0x1000007D;
const PROPERTY_XPMULT = 0x1000007E;
const PROPERTY_GPMULT = 0x1000007F;
const PROPERTY_CPMULT = 0x10000080;
const PROPERTY_GAMESTATE = 0x10000081;
const PROPERTY_TIMEREMAINING = 0x10000082;
const PROPERTY_PLAYLISTINFO1 = 0x10000083;
const PROPERTY_PLAYLISTINFO2 = 0x10000084;
const PROPERTY_PLAYLISTINFO3 = 0x10000085;
const PROPERTY_PLAYLISTINFO4 = 0x10000086;
const PROPERTY_MAX_TICK_RATE = 0x10000087;
const PROPERTY_PREMIUMTOKENGUID = 0x10000088;
const PROPERTY_ADVERTISEDXPMULT = 0x10000089;
const PROPERTY_ADVERTISEDCPMULT = 0x1000008A;
const PROPERTY_ADVERTISEDGPMULT = 0x1000008B;
const PROPERTY_MUTATORTOGGLE = 0x1000008C;
const PROPERTY_NUM_BOTS = 0x1000008D;
const PROPERTY_MAX_CP = 0x1000008E;
const PROPERTY_STARTING_CP = 0x1000008F;
const PROPERTY_PING_THRESHOLD = 0x10000090;
const PROPERTY_TIME_LIMIT = 0x10000091;
const PROPERTY_GOALSCORE_MULT = 0x10000092;
const PROPERTY_SERVERACCESSTYPE = 0x10000093;
const PROPERTY_PLAYERWHITELIST = 0x10000094;
const PROPERTY_CLANWHITELIST = 0x10000095;
const PROPERTY_BANLIST = 0x10000096;
const PROPERTY_RANDOMPLAYLIST = 0x10000097;
const PROPERTY_REGIONTAG = 0x10000098;
const PROPERTY_SERVERTYPE = 0x10000099;
const PROPERTY_QUERYPREMIUM = 0x1000009A;
const PROPERTY_OWNERID = 0x1000009B;
const PROPERTY_MAXPLAYERS = 0x1000009C;
const PROPERTY_MAXSPECTATORS = 0x1000009D;
const PROPERTY_PREMIUM_SERVER_GUID = 0x1000009E;
const PROPERTY_SERVER_EXPIRATION = 0x1000009F;
const PROPERTY_SAVEDMAPINFO1 = 0x10000100;
const PROPERTY_SAVEDMAPINFO2 = 0x10000101;
const PROPERTY_SAVEDMAPINFO3 = 0x10000102;
const PROPERTY_SAVEDGAMEMODEINFO1 = 0x10000103;
const PROPERTY_SAVEDGAMEMODEINFO2 = 0x10000104;
const PROPERTY_DIFFICULTY = 0x10000105;
const PROPERTY_SAVEDMAPINFO4 = 0x10000106;
const PROPERTY_SERVERPREFIX = 0x10000107;
const PROPERTY_HEALTH_MULTIPLIER = 0x10000108;
const PROPERTY_ADMINLIST = 0x10000109;
const PROPERTY_ADVERTISED_TIMELIMIT = 0x1000010A;
const PROPERTY_STAMINA_MULTIPLIER = 0x1000010B;
const PROPERTY_NUM_ROUNDS = 0x1000010C;
const PROPERTY_ADVERTISED_ROUND = 0x1000010D;
const PROPERTY_TEAM_TICKETS = 0x1000010E;
const PROPERTY_PERSONAL_TICKETS = 0x1000010F;
const PROPERTY_ROUND_TEAM_SWAP = 0x10000110;
const PROPERTY_NUM_SPECTATORS = 0x10000111;
const PROPERTY_PLAYLIST_INDEX = 0x10001000;
const PROPERTY_PROFILE_SKILL = 0x10001001;
const PROPERTY_PROFILE_RANK_INDEX = 0x10001010;
const PROPERTY_PLAYLIST_SEARCH_FILTER = 0x10001011;
const PROPERTY_NUM_PLAYLIST_MAX = 0x10001012;
const PROPERTY_MINPRESTIGE = 0x10001013;
const PROPERTY_MAXPRESTIGE = 0x10001014;
const QUERY_DM = 0;
const QUERY_TDM = 1;
const QUERY_CP = 2;
const QUERY_DETONATE = 3;
const QUERY_CTF = 4;
const QUERY_CTDM = 5;
const QUERY_LMS = 6;
const QUERY_LTS = 7;
const QUERY_BO = 8;
const QUERY_TKOTH = 9;
const QUERY_EOTS = 10;
const QUERY_PL = 11;
const QUERY_KC = 12;
const QUERY_SND = 13;
const PROPERTY_LEADERBOARDRATING = 0x20000009;
const STATS_VIEW_LEADERBOARD_PLAYERALLTIME = 1;
const STATS_VIEW_LEADERBOARD_RANKEDALLTIME = 2;
const STATS_VIEW_LEADERBOARD_PLAYERALLTIME_DM = 3;
const STATS_VIEW_LEADERBOARD_PLAYERALLTIME_TDM = 4;
const STATS_VIEW_LEADERBOARD_PLAYERALLTIME_CTF = 5;
const STATS_VIEW_LEADERBOARD_PLAYERALLTIME_CP = 6;
const STATS_VIEW_LEADERBOARD_PLAYERALLTIME_DET = 7;
const STATS_VIEW_LEADERBOARD_PLAYERALLTIME_LMS = 8;
const STATS_VIEW_LEADERBOARD_PLAYERALLTIME_LTS = 9;
const STATS_VIEW_LEADERBOARD_PLAYERALLTIME_BO = 10;
const STATS_VIEW_LEADERBOARD_WEAPONSALLTIME = 11;
const STATS_VIEW_LEADERBOARD_PLAYERALLTIME_PS3 = 12;
const STATS_VIEW_PROFILESTATS = 13;
const MIN_ENTRIES = 12;

struct native ServerDetailListEntry
{
    var string sName;
    var bool bNoInteraction;
    var bool bIsDisabled;
    var bool bIsCurrent;
    var string sIcon;

    structdefaultproperties
    {
        sName=""
        bNoInteraction=false
        bIsDisabled=false
        bIsCurrent=false
        sIcon=""
    }
};

var FoxPC PCOwner;
var private transient ServerListEntry CurrentEntry;
var private transient FoxDataStore_Playlists PlaylistDataStore;
var private transient array<FoxDataProvider_GameModeInfo> GameModeProviders;
var private transient array<FoxDataProvider_PlaylistGameInfo> PlaylistGameProviders;
var private transient array<FoxDataProvider_MapInfo> MapInfoProviders;
var const localized string CycleLabel;
var const localized string RandomLabel;
var const localized string JoinButtonLabel;
var const localized string JoinButtonTooltip;
var const localized string WatchButtonLabel;
var const localized string WatchButtonTooltip;
var const localized string EditButtonLabel;
var const localized string EditButtonToolTip;
var const localized string DeleteButtonLabel;
var const localized string DeleteButtonToolTip;
var delegate<OnJoinServerEntry> __OnJoinServerEntry__Delegate;

delegate OnJoinServerEntry(ServerListEntry ServerEntry)
{
    //return;    
}

function Initialize()
{
    GetDataProviders();
    ClearServerDetails();
    //return;    
}

function UpdateServerDetails(ServerListEntry Entry)
{
    local FoxDataProvider_Playlist FoundPlayList;
    local array<MutatorInfo> Mutators;
    local MutatorInfo MutatorEntry;
    local int I;

    CurrentEntry = Entry;
    // End:0x107
    if(Len(Entry.sRealPlaylistName) > 0)
    {
        // End:0x98
        if(PlaylistDataStore == none)
        {
            PlaylistDataStore = FoxDataStore_Playlists(class'UIInteraction'.static.GetDataStoreClient().FindDataStore('FoxPlaylists'));
        }
        FoundPlayList = PlaylistDataStore.GetPlaylistByName(name(Entry.sRealPlaylistName));
        // End:0x104
        if(FoundPlayList != none)
        {
            SetDetailsForPlaylist(FoundPlayList);
            J0x104:
        }
        // End:0x104
        else
        {
        }
    }
    // End:0x130
    else
    {
        SetDetailsFromPlaylistSettings(Entry.GameSettings, none);
    }
    SetString("serverName", Entry.sServerName);
    // End:0x7C1
    if(Entry.GameSettings != none)
    {
        as_updateServerDataInfo(class'FoxUIServerListWidget'.static.GetMutatorStringsForGameSettings(Entry.GameSettings));
        SetBool("bHasPassword", Entry.bHasPassword);
        I = 0;
        J0x20A:
        // End:0x3C0 [Loop If]
        if(I < class'FoxSettingsUIPrivateMatchBase'.default.GearMutators.Length)
        {
            MutatorEntry = class'FoxSettingsUIPrivateMatchBase'.default.GearMutators[I];
            // End:0x3B2
            if(Entry.GameSettings.IsMutatorSettingEnabled(MutatorEntry.Mutator))
            {
                MutatorEntry.sName = GetLocalizedString(MutatorEntry.sName, "SERVERBROWSER");
                MutatorEntry.sTooltip = GetLocalizedString(MutatorEntry.sTooltip, "SERVERBROWSER");
                MutatorEntry.bDisabled = true;
                MutatorEntry.bSelected = true;
                Mutators.AddItem(MutatorEntry);
            }
            ++ I;
            // [Loop Continue]
            goto J0x20A;
        }
        I = 0;
        J0x3CB:
        // End:0x581 [Loop If]
        if(I < class'FoxSettingsUIPrivateMatchBase'.default.GameplayMutators.Length)
        {
            MutatorEntry = class'FoxSettingsUIPrivateMatchBase'.default.GameplayMutators[I];
            // End:0x573
            if(Entry.GameSettings.IsMutatorSettingEnabled(MutatorEntry.Mutator))
            {
                MutatorEntry.sName = GetLocalizedString(MutatorEntry.sName, "SERVERBROWSER");
                MutatorEntry.sTooltip = GetLocalizedString(MutatorEntry.sTooltip, "SERVERBROWSER");
                MutatorEntry.bDisabled = true;
                MutatorEntry.bSelected = true;
                Mutators.AddItem(MutatorEntry);
            }
            ++ I;
            // [Loop Continue]
            goto J0x3CB;
        }
        I = 0;
        J0x58C:
        // End:0x742 [Loop If]
        if(I < class'FoxSettingsUIPrivateMatchBase'.default.MapMutators.Length)
        {
            MutatorEntry = class'FoxSettingsUIPrivateMatchBase'.default.MapMutators[I];
            // End:0x734
            if(Entry.GameSettings.IsMutatorSettingEnabled(MutatorEntry.Mutator))
            {
                MutatorEntry.sName = GetLocalizedString(MutatorEntry.sName, "SERVERBROWSER");
                MutatorEntry.sTooltip = GetLocalizedString(MutatorEntry.sTooltip, "SERVERBROWSER");
                MutatorEntry.bDisabled = true;
                MutatorEntry.bSelected = true;
                Mutators.AddItem(MutatorEntry);
            }
            ++ I;
            // [Loop Continue]
            goto J0x58C;
        }
        // End:0x78F
        if(Mutators.Length > 0)
        {
            SetString("mutatorHeader", GetLocalizedString("activemutatorslabel"));
        }
        // End:0x7AB
        else
        {
            SetString("mutatorHeader", "");
        }
        as_updateMutatorGridData(Mutators);
        J0x7C1:
    }
    // End:0x7C1
    else
    {
    }
    //return;    
}

function ClearServerDetails(optional bool bPartial)
{
    // End:0x1E
    if(!bPartial)
    {
        as_updateMapList();
        J0x1E:
    }
    // End:0x1E
    else
    {
    }
    //return;    
}

function FoxDataProvider_MapInfo GetMapInfoByName(const array<FoxDataProvider_MapInfo> MapProviders, name MapName)
{
    local int I;

    I = 0;
    J0x0B:
    // End:0x7B [Loop If]
    if(I < MapProviders.Length)
    {
        // End:0x6D
        if(MapProviders[I].Name == MapName)
        {
            return MapProviders[I];
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    return none;
    //return ReturnValue;    
}

function FoxDataProvider_GameModeInfo GetGameModeInfoByName(const array<FoxDataProvider_GameModeInfo> GameProviders, name GameModeName)
{
    local int I;

    I = 0;
    J0x0B:
    // End:0x7B [Loop If]
    if(I < GameProviders.Length)
    {
        // End:0x6D
        if(GameProviders[I].AbbreviatedName == GameModeName)
        {
            return GameProviders[I];
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    return none;
    //return ReturnValue;    
}

function SetDetailsForPlaylist(const FoxDataProvider_Playlist InPlaylist)
{
    local int I, nUniqueMaps, nUniqueGameModes;
    local array<int> MapIndices, GameModeIndices;
    local class<FoxGame> GameClass;
    local array<ServerDetailListEntry> MapDetailEntries, GameModeDetailEntries;
    local array<FoxDataProvider_MapInfo> MapInfoList;
    local array<FoxDataProvider_GameModeInfo> GameModeList;

    PlaylistDataStore.BuildPlaylistInfoByProvider(InPlaylist, MapInfoList, GameModeList);
    I = 0;
    J0x46:
    // End:0x9C [Loop If]
    if(I < MapInfoList.Length)
    {
        AddMapListEntry(MapIndices, MapInfoList[I], nUniqueMaps);
        ++ I;
        // [Loop Continue]
        goto J0x46;
    }
    I = 0;
    J0xA7:
    // End:0xFD [Loop If]
    if(I < GameModeList.Length)
    {
        AddGameModeListEntry(GameModeIndices, GameModeList[I], nUniqueGameModes);
        ++ I;
        // [Loop Continue]
        goto J0xA7;
    }
    // End:0x178
    if(nUniqueMaps == 1)
    {
        AddDetailListEntry(MapDetailEntries, MapInfoProviders[MapIndices[0]].FriendlyName, MapInfoProviders[MapIndices[0]].LargePreviewImageMarkup);
    }
    // End:0x222
    else
    {
        I = 0;
        J0x183:
        // End:0x222 [Loop If]
        if(I < MapIndices.Length)
        {
            AddDetailListEntry(MapDetailEntries, MapInfoProviders[MapIndices[I]].FriendlyName, MapInfoProviders[MapIndices[I]].LargePreviewImageMarkup);
            ++ I;
            // [Loop Continue]
            goto J0x183;
        }
    }
    // End:0x2C8
    if(nUniqueGameModes == 1)
    {
        GameClass = class<FoxGame>(DynamicLoadObject(GameModeProviders[GameModeIndices[0]].GameMode, class'Class'));
        // End:0x2C5
        if(GameClass != none)
        {
            AddDetailListEntry(GameModeDetailEntries, GameClass.default.GameTypeString);
        }
    }
    // End:0x395
    else
    {
        I = 0;
        J0x2D3:
        // End:0x395 [Loop If]
        if(I < GameModeIndices.Length)
        {
            GameClass = class<FoxGame>(DynamicLoadObject(GameModeProviders[GameModeIndices[I]].GameMode, class'Class'));
            // End:0x387
            if(GameClass != none)
            {
                AddDetailListEntry(GameModeDetailEntries, GameClass.default.GameTypeString);
            }
            ++ I;
            // [Loop Continue]
            goto J0x2D3;
        }
    }
    as_updateMapList(MapDetailEntries);
    //return;    
}

function SetDetailsFromPlaylistSettings(const FoxGameSettingsCommon InGameSettings, const FoxDataProvider_Playlist InPlaylist, optional bool bWeOwnServer, optional bool bWeHaveAdminAccess)
{
    local int I, nUniqueMaps, nUniqueGameModes, SelectedMapIndex, SelectedGameModeIndex;

    local array<int> MapIndices, GameModeIndices, PotentialSelectedMapIndices, PotentialSelectedGameModeIndices;
    local class<FoxGame> GameClass;
    local array<ServerDetailListEntry> MapDetailEntries, GameModeDetailEntries;
    local array<FoxDataProvider_MapInfo> MapInfoList;
    local array<FoxDataProvider_GameModeInfo> GameModeList;

    // End:0x42
    if(InGameSettings != none)
    {
        InGameSettings.GetBuildPlaylistInfo(MapInfoList, GameModeList);
    }
    SelectedMapIndex = -1;
    SelectedGameModeIndex = -1;
    I = 0;
    J0x6B:
    // End:0xC1 [Loop If]
    if(I < MapInfoList.Length)
    {
        AddMapListEntry(MapIndices, MapInfoList[I], nUniqueMaps);
        ++ I;
        // [Loop Continue]
        goto J0x6B;
    }
    I = 0;
    J0xCC:
    // End:0x122 [Loop If]
    if(I < GameModeList.Length)
    {
        AddGameModeListEntry(GameModeIndices, GameModeList[I], nUniqueGameModes);
        ++ I;
        // [Loop Continue]
        goto J0xCC;
    }
    I = 0;
    J0x12D:
    // End:0x25B [Loop If]
    if(I < MapIndices.Length)
    {
        AddDetailListEntry(MapDetailEntries, (MapInfoProviders[MapIndices[I]].FriendlyName @ "/") @ GameModeProviders[GameModeIndices[I % GameModeIndices.Length]].FriendlyAbbreviatedName, MapInfoProviders[MapIndices[I]].LargePreviewImageMarkup);
        // End:0x24D
        if(MapIndices[I] == CurrentEntry.MapIndex)
        {
            PotentialSelectedMapIndices.AddItem(I);
        }
        ++ I;
        // [Loop Continue]
        goto J0x12D;
    }
    I = 0;
    J0x266:
    // End:0x372 [Loop If]
    if(I < GameModeIndices.Length)
    {
        GameClass = class<FoxGame>(DynamicLoadObject(GameModeProviders[GameModeIndices[I]].GameMode, class'Class'));
        // End:0x364
        if(GameClass != none)
        {
            AddDetailListEntry(GameModeDetailEntries, GameClass.default.GameTypeString);
            // End:0x364
            if(GameModeIndices[I] == CurrentEntry.GameModeIndex)
            {
                PotentialSelectedGameModeIndices.AddItem(I);
            }
        }
        ++ I;
        // [Loop Continue]
        goto J0x266;
    }
    // End:0x418
    if((PotentialSelectedMapIndices.Length > 0) && PotentialSelectedGameModeIndices.Length > 0)
    {
        I = 0;
        J0x39F:
        // End:0x418 [Loop If]
        if(I < PotentialSelectedMapIndices.Length)
        {
            SelectedGameModeIndex = PotentialSelectedGameModeIndices.Find(PotentialSelectedMapIndices[I]);
            // End:0x40A
            if(SelectedGameModeIndex != -1)
            {
                SelectedMapIndex = I;
                // [Explicit Break]
                goto J0x418;
            }
            ++ I;
            J0x418:
            // [Loop Continue]
            goto J0x39F;
        }
    }
    // End:0x46A
    if((SelectedMapIndex >= 0) && SelectedMapIndex < MapDetailEntries.Length)
    {
        MapDetailEntries[SelectedMapIndex].bIsCurrent = true;
    }
    // End:0x4BC
    if((SelectedGameModeIndex >= 0) && SelectedGameModeIndex < GameModeDetailEntries.Length)
    {
        GameModeDetailEntries[SelectedGameModeIndex].bIsCurrent = true;
    }
    as_updateMapList(MapDetailEntries);
    //return;    
}

protected function AddDetailListEntry(out array<ServerDetailListEntry> DetailList, string EntryName, optional string mapImage, optional bool bCanInteract, optional bool bIsDisabled)
{
    local ServerDetailListEntry DetailEntry;

    bCanInteract = false;
    bIsDisabled = false;
    class'FoxUI'.static.GetFormattedNumber(float(DetailList.Length + 1), DetailEntry.sName, 0, 2);
    DetailEntry.sName @= EntryName;
    DetailEntry.bNoInteraction = !bCanInteract || bIsDisabled;
    DetailEntry.bIsDisabled = bIsDisabled;
    DetailEntry.sIcon = PCOwner.DynamicUI.MarkupImageString(mapImage);
    DetailList.AddItem(DetailEntry);
    //return;    
}

protected function AddEmptyEntries(out array<ServerDetailListEntry> DetailList, optional string EmptyEntryName)
{

    J0x01:    // End:0x2E [Loop If]
    if(DetailList.Length < 12)
    {
        AddDetailListEntry(DetailList, "", "", false, true);
        // [Loop Continue]
        goto J0x01;
    }
    //return;    
}

function SetAccessType(const optional out ServerAccessDisplayInfo DisplayInfo)
{
    local string AccessLabel;

    AccessLabel = GetLocalizedString(DisplayInfo.AccessLabel);
    SetString("modeTypeText", AccessLabel);
    //return;    
}

function SetDesignationType(const optional out ServerDesignationDisplayInfo DisplayInfo)
{
    local string DesignationLabel;

    DesignationLabel = GetLocalizedString(DisplayInfo.DesignationLabel);
    SetString("typeTypeText", DesignationLabel);
    //return;    
}

function SetOwnerName(optional string OwnerName)
{
    SetString("adminNameText", OwnerName);
    //return;    
}

function SetGameCycleType(bool bRandom)
{
    local string ModeLabel;

    ModeLabel = ((bRandom) ? RandomLabel : CycleLabel);
    SetString("gameTypeText", ModeLabel);
    //return;    
}

function SetMapCycleType(bool bRandom)
{
    local string ModeLabel;

    ModeLabel = ((bRandom) ? RandomLabel : CycleLabel);
    SetString("mapTypeText", ModeLabel);
    //return;    
}

function SetAgentCount(int nAgents, optional int nSpectators)
{
    nSpectators = -1;
    SetString("agentsNumberText", string(nAgents));
    // End:0x6C
    if(nSpectators >= 0)
    {
        SetString("spectatorsNumberText", string(nSpectators));
    }
    //return;    
}

function SetPlaylistDetailsText(const FoxDataProvider_Playlist Playlist)
{
    SetString("detailedText", Playlist.FriendlyDescription);
    //return;    
}

function AddMapListEntry(out array<int> MapIndices, FoxDataProvider_MapInfo MapInfoProvider, out int nUnique, optional bool bUnique)
{
    local int I, ExistingIndex;

    // End:0xCC
    if(MapInfoProvider != none)
    {
        I = 0;
        J0x1B:
        // End:0xCC [Loop If]
        if(I < MapInfoProviders.Length)
        {
            // End:0xBE
            if(MapInfoProviders[I] == MapInfoProvider)
            {
                ExistingIndex = MapIndices.Find(I);
                // End:0x95
                if(ExistingIndex == -1)
                {
                    ++ nUnique;
                }
                // End:0xA5
                else
                {
                    // End:0xA5
                    if(bUnique)
                    {
                        // [Explicit Break]
                        goto J0xCC;
                    }
                }
                MapIndices.AddItem(I);
                // [Explicit Break]
                goto J0xCC;
            }
            ++ I;
            J0xCC:
            // [Loop Continue]
            goto J0x1B;
        }
    }
    //return;    
}

function AddGameModeListEntry(out array<int> GameModeIndices, FoxDataProvider_GameModeInfo GameMode, out int nUnique, optional bool bUnique)
{
    local int I, ExistingIndex;

    // End:0xCC
    if(GameMode != none)
    {
        I = 0;
        J0x1B:
        // End:0xCC [Loop If]
        if(I < GameModeProviders.Length)
        {
            // End:0xBE
            if(GameModeProviders[I] == GameMode)
            {
                ExistingIndex = GameModeIndices.Find(I);
                // End:0x95
                if(ExistingIndex == -1)
                {
                    ++ nUnique;
                }
                // End:0xA5
                else
                {
                    // End:0xA5
                    if(bUnique)
                    {
                        // [Explicit Break]
                        goto J0xCC;
                    }
                }
                GameModeIndices.AddItem(I);
                // [Explicit Break]
                goto J0xCC;
            }
            ++ I;
            J0xCC:
            // [Loop Continue]
            goto J0x1B;
        }
    }
    //return;    
}

private final function GetDataProviders()
{
    local FoxDataProvider_MapInfo MapInfoProvider;
    local FoxDataProvider_PlaylistGameInfo PlaylistGameProvider;
    local FoxDataProvider_GameModeInfo GameModeProvider;
    local DataStoreClient DataStoreClient;
    local FoxDataStore_MenuItems MenuItemsDataStore;
    local FoxDataStore_Playlists PlaylistsDataStore;
    local int I;

    DataStoreClient = class'UIInteraction'.static.GetDataStoreClient();
    // End:0x2DB
    if(DataStoreClient != none)
    {
        MenuItemsDataStore = FoxDataStore_MenuItems(DataStoreClient.FindDataStore('FoxMenuItems'));
        // End:0x1E7
        if(MenuItemsDataStore != none)
        {
            MapInfoProviders.Length = 0;
            I = 0;
            J0x9A:
            // End:0x135 [Loop If]
            if(I < MenuItemsDataStore.MapProviders.Length)
            {
                MapInfoProvider = FoxDataProvider_MapInfo(MenuItemsDataStore.MapProviders[I]);
                // End:0x127
                if(MapInfoProvider != none)
                {
                    MapInfoProviders.AddItem(MapInfoProvider);
                }
                ++ I;
                // [Loop Continue]
                goto J0x9A;
            }
            GameModeProviders.Length = 0;
            I = 0;
            J0x14C:
            // End:0x1E7 [Loop If]
            if(I < MenuItemsDataStore.GameModeProviders.Length)
            {
                GameModeProvider = FoxDataProvider_GameModeInfo(MenuItemsDataStore.GameModeProviders[I]);
                // End:0x1D9
                if(GameModeProvider != none)
                {
                    GameModeProviders.AddItem(GameModeProvider);
                }
                ++ I;
                // [Loop Continue]
                goto J0x14C;
            }
        }
        PlaylistsDataStore = FoxDataStore_Playlists(DataStoreClient.FindDataStore('FoxPlaylists'));
        // End:0x2DB
        if(PlaylistsDataStore != none)
        {
            PlaylistGameProviders.Length = 0;
            I = 0;
            J0x249:
            // End:0x2DB [Loop If]
            if(I < PlaylistsDataStore.PlaylistGameInfoProviders.Length)
            {
                PlaylistGameProvider = PlaylistsDataStore.PlaylistGameInfoProviders[I];
                // End:0x2CD
                if(PlaylistGameProvider != none)
                {
                    PlaylistGameProviders.AddItem(PlaylistGameProvider);
                }
                ++ I;
                // [Loop Continue]
                goto J0x249;
            }
        }
    }
    //return;    
}

function as_joinButtonInfo(string Label, string ToolTip, string ExtClickFunc, string ExtClickArg, bool bDisabled)
{
    ActionScriptVoid("joinButtonInfo");
    //return;    
}

function as_watchButtonInfo(string Label, string ToolTip, string ExtClickFunc, string ExtClickArg, bool bDisabled)
{
    ActionScriptVoid("watchButtonInfo");
    //return;    
}

function as_manageButtonInfo(string Label, string ToolTip, string ExtClickFunc, string ExtClickArg, bool bDisabled)
{
    ActionScriptVoid("manageButtonInfo");
    //return;    
}

function AddDeleteButton()
{
    as_deleteButtonInfo(DeleteButtonLabel, DeleteButtonToolTip, "ei_DeleteServerClicked", "", false);
    //return;    
}

function as_deleteButtonInfo(string Label, string ToolTip, string ExtClickFunc, string ExtClickArg, bool bDisabled)
{
    ActionScriptVoid("destroyButtonInfo");
    //return;    
}

function as_updateMapList(optional array<ServerDetailListEntry> DataProvider)
{
    ActionScriptVoid("updateMapList");
    //return;    
}

function as_updateGameModeList(optional array<ServerDetailListEntry> DataProvider)
{
    ActionScriptVoid("updateGametypeList");
    //return;    
}

function as_clearServerDetail()
{
    ActionScriptVoid("clearDetails");
    //return;    
}

event as_forceCycleNextMap()
{
    ActionScriptVoid("forceNextMap");
    //return;    
}

event as_forceCyclePrevMap()
{
    ActionScriptVoid("forcePrevMap");
    //return;    
}

function as_updateMutatorGridData(array<MutatorInfo> GridData)
{
    ActionScriptVoid("mutatorGridData");
    //return;    
}

function as_updateServerDataInfo(array<ServerStatListEntry> DataProvider)
{
    ActionScriptVoid("updateServerDataInfo");
    //return;    
}

defaultproperties
{
    CurrentEntry=(sServerName="",sMapName="",sGametype="",sAdminName="",sRestrictText="",sCurrentPlayers="",sMaxPlayers="",nBarCount=0,bIsLocked=false,bRestricted=false,bEnding=false,bHasPassword=false,nServerType=0,ServerIndex=0,bWeOwn=false,bWeHaveAdminAccess=false,MapIndex=0,GameModeIndex=0,nCurrentPlayers=0,nCurrentSpectators=0,nMaxPlayers=0,MinLevel=0,MaxLevel=0,MinPrestige=0,MaxPrestige=0,sPlayListName="",sRealPlaylistName="",sNextLabel="",sNextGametype="",sNextMap="",sMapImageLoc="",GameSettings=none,AccessInfo=(AccessType=EServerAccessType.ESAT_Public,AccessLabel="",bIsLocked=false),DesignationInfo=(DesignationType=EServerDesignationType.EST_StandardPrivate,TitleLabel="",AdminNameLabel="",DesignationLabel="",nIcon=EServerDesignationIcon.ESDI_None),Address="",sTooltip="",bHasMutators=false,sDescription="",sKeyPrompt="",bUseInSearch=false,sSearchTooltip="",sSearchFunction="",bIsPlaylist=false,bDisabled=false,bFeatured=false)
    CycleLabel="Cycle"
    RandomLabel="Random"
    JoinButtonLabel="JOIN"
    JoinButtonTooltip="Click to join this server"
    WatchButtonLabel="SPECTATE"
    WatchButtonTooltip="Click to spectate this server"
    EditButtonLabel="MANAGE"
    EditButtonToolTip="Click to change the properties of your server"
    DeleteButtonLabel="DESTROY"
    DeleteButtonToolTip="Click to destroy this server"
    LocalizationPackageName="FoxMenuUI"
    LocalizationSectionName="ServerBrowser"
}